"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.replaceVariables = exports.replaceAll = exports.getRegExp = exports.escapeRegExp = void 0;
const escapeRegExp = (text) => text.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
exports.escapeRegExp = escapeRegExp;
const getRegExp = (value) => new RegExp(exports.escapeRegExp(value));
exports.getRegExp = getRegExp;
const replaceAll = (string, key, value) => string.split(key).join(value);
exports.replaceAll = replaceAll;
const replaceVariables = (string, variables) => {
    let replaced = string;
    for (const variable of variables) {
        if (exports.getRegExp(`\${${variable.key}}`).test(replaced)) {
            replaced = exports.replaceAll(replaced, `\${${variable.key}}`, variable.replace);
        }
    }
    return replaced;
};
exports.replaceVariables = replaceVariables;
